package ssw.mj.symtab;

/**
 * MicroJava Symbol Table Scopes
 */
public class Scope {
	/** Reference to enclosing scope. */
	public Scope outer;
	/** Declarations of this scope. */
	public Obj locals;
	/** Number of variables in this scope. */
	public int nVars;

	/**
	 * String representation for JUnit test cases.
	 */
	public void dump(StringBuilder sb) {
		sb.append("-- begin scope (").append(nVars).append(" variables) --\n");
		if (locals != null) {
			locals.dump(sb, "", false, true);
		}
		if (outer != null) {
			sb.append("\n");
			outer.dump(sb);
		}
	}
}
